function g = pf(m,M,z)
  y      = z.y;
  N      = size(y,2);     % Number of samples
  xPWeighted  = zeros(N,M);      % Make some room
  xPResampled = zeros(N,M);      % Make some room
  wStore      = zeros(N,M);
  xhat        = zeros(1,N);

  % 1. Initialize particles
  if m.ss.P1==0
    x = repmat(m.ss.X1,1,M);    % Initial state fully known
  else
    x = repmat(m.ss.X1,1,M)+sqrtm(m.ss.P1)*randn(1,M);
  end;
  for t=1:N
    x = m.ss.A*x + sqrtm(m.ss.Q)*randn(1,M); % 2. Predict the particles 
    e = repmat(y(t),1,M) - m.ss.C*x;
    w = exp(-0.5*e.^2/m.ss.R);               % 3. Evaluate the likelihood
    w = w/sum(w);
    xPWeighted(t,:) = x;
    wStore(t,:) = w;
    xhat(t) = sum(w.*x,2);                   % Compute state estimate
    index = sysresample(w);                  % 4. Resample
    x = x(index);
    xPResampled(t,:) = x;
  end;
g.xPWeighted  = xPWeighted;
g.xPResampled = xPResampled;
g.w           = wStore;
g.Xf          = xhat;
end